<?php
/**
* JoomBlog component for Joomla
* @version $Id: install.joomblog.php 2011-03-16 17:30:15
* @package JoomBlog
* @subpackage install.joomblog.php
* @author JoomPlace Team
* @Copyright Copyright (C) JoomPlace, www.joomplace.com
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

define( "SITE_ROOT_PATH", JPATH_ROOT );

jimport( 'joomla.filesystem.file' );
jimport( 'joomla.filesystem.folder' );
jimport( 'joomla.filesystem.archive' );

class com_joomblogInstallerScript
{
        /**
         * method to install the component
         *
         * @return void
         */
        function install($parent) 
        {

        }
 
        /**
         * method to uninstall the component
         *
         * @return void
         */
        function uninstall($parent) 
        {
			  $db	=& JFactory::getDBO();
			  $db->setQuery("DELETE FROM #__menu WHERE path = 'joomblog' AND type = 'component' AND client_id = 1 AND menutype = 'main' AND link LIKE 'index.php?option=com_joomblog%' ");
			  $db->query();
			 
			//
        }
 
        /**
         * method to update the component
         *
         * @return void
         */
        function update($parent) 
        {
			$db		=& JFactory::getDBO();
			
			$db->setQuery("SELECT `params` FROM `#__extensions` WHERE element='com_joomblog'");
			$config = $db->loadResult();
			
			if (!$config || $config=='{}' || $config=='[]')
			{
			$db->setQuery("SELECT `value` FROM #__joomblog_config ");
			$configString = $db->loadResult();
			
			$confa = $configArray = array();
			if ($configString) $configArray = explode(';',$configString);
			foreach ( $configArray as $config ) 
			{
				$name  = substr(trim($config),1,strpos($config,'="')-1);
				$name = str_replace('="','',$name);
				$name = str_replace('=','',$name);
				$value = substr(trim($config),strpos(trim($config),'="')+2,-1);
				$confa[$name] = $value;
			}
			$config = json_encode($confa);
			}
			
			$db->setQuery("UPDATE #__extensions SET params=".$db->Quote($config)." WHERE element='com_joomblog'");
			$db->query();	
			
			
			
			 //ver 1.0.3
			  
				$query = "CREATE TABLE IF NOT EXISTS `#__joomblog_multicats` (
				  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
				  `aid` int(10) unsigned NOT NULL,
				  `cid` int(10) unsigned NOT NULL,
				  PRIMARY KEY (`id`)
				) ENGINE=MyISAM  DEFAULT CHARSET=utf8";
				$db->setQuery($query);
				$db->query();
				
				$query ="CREATE TABLE IF NOT EXISTS `#__joomblog_privacy` (
				  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
				  `postid` int(11) NOT NULL,
				  `posts` int(10) unsigned NOT NULL,
				  `comments` int(10) unsigned NOT NULL,
				  `isblog`  TINYINT UNSIGNED NOT NULL,
				  PRIMARY KEY (`id`)
				)";
				$db->setQuery($query);
				$db->query();
				
				$query	= "ALTER TABLE `#__joomblog_list_blogs` ADD `asset_id` INT UNSIGNED NOT NULL , ADD `approved` TINYINT UNSIGNED NOT NULL DEFAULT '1' ";
				$db->setQuery($query);
				$db->query();	

				$query	= "ALTER TABLE `#__joomblog_privacy` ADD `isblog` TINYINT UNSIGNED NOT NULL";
				$db->setQuery($query);
				$db->query();	

				$query	= "ALTER TABLE `#__joomblog_list_blogs` ADD `alias` VARCHAR( 255 ) NOT NULL AFTER `title` ";
				$db->setQuery($query);
				$db->query();
				
				
				$query = "SELECT * FROM `#__joomblog_list_blogs` WHERE id NOT IN (SELECT postid FROM `#__joomblog_privacy` WHERE `isblog`=1 )";
				$db->setQuery( $query );
				$bids = $db->loadResultArray();
				if (sizeof($bids))
				{
					foreach($bids as $bid)
					{
						$query = "INSERT INTO `#__joomblog_privacy` (`id` ,`postid` ,`posts` ,`comments` ,`isblog`) VALUES (NULL , '".$bid."', '0', '0', '1');";
						$db->setQuery( $query );
						$db->query();
					}
				}
				
				$query = "SELECT id FROM `#__joomblog_blogs` WHERE content_id NOT IN (SELECT id FROM `#__content`)";
				$db->setQuery( $query );
				$cids = $db->loadResultArray();
				if (sizeof($cids))
				{
					foreach($cids as $cid)
					{
						$query = "DELETE `#__joomblog_blogs`  WHERE id ='".$cid."'";
						$db->setQuery( $query );
						$db->query();
					}
				}
				
				$query = "SELECT `id` , `catid` FROM `#__content` WHERE id IN (SELECT `content_id` FROM `#__joomblog_blogs`)";
				$db->setQuery( $query );
				$ids = $db->loadObjectList();
				
				if (sizeof($ids))
				{
					foreach($ids as $id)
					{
						$query = "SELECT `id`  FROM `#__joomblog_multicats` WHERE `aid` ='".$id->id."'";
						$db->setQuery( $query );
						$mid = $db->loadResult();
						if (!$mid)
						{
							$query = "INSERT INTO `#__joomblog_multicats` (`id` ,`aid` ,`cid`) VALUES (NULL , '".$id->id."', '".$id->catid."');";
							$db->setQuery( $query );
							$db->query();
						}
					}
				}
				
				//**Tags fix*/
				$query = "ALTER TABLE #__joomblog_tags DROP INDEX `name`";
				$db->setQuery( $query );
				$db->query();
				
				/*** BLOG SEF FIX ***/
					$query = "SELECT `id`,`title` FROM `#__joomblog_list_blogs` WHERE `alias`=''";
					$db->setQuery( $query );
					$bids = $db->loadObjectList();
					if (sizeof($bids))
					{
						foreach($bids as $bid)
						{
							$alias = JFilterOutput::stringURLSafe($bid->title);
							$query = "UPDATE `#__joomblog_list_blogs` SET `alias` ='".$alias."'  WHERE `id` =".$bid->id." LIMIT 1 ";
							$db->setQuery($query);
							$db->query();
						}
					}
				/*** ***/
        }
 
        /**
         * method to run before an install/update/uninstall method
         *
         * @return void
         */
        function preflight($type, $parent) 
        {

		$pathes = $files =array();
			
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/controllers";
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/helpers";
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/images";
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/install";
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/models";
			$pathes[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/views";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/css";
			//$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/images";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/js";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/libraries";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/tables";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/task";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/templates";
			$pathes[]= SITE_ROOT_PATH . "/components/com_joomblog/views";
			
			if (sizeof($pathes))
			foreach ($pathes as $path)
			{
				if (JFolder::exists($path)) JFolder::delete($path);
			}
			

			$files[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/admin.joomblog.html.php";
			$files[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/admin.joomblog.php";
			$files[]= SITE_ROOT_PATH . "/administrator/components/com_joomblog/toolbar.joomblog.php";
			
			$files[]= SITE_ROOT_PATH . "/components/com_joomblog/defines.joomblog.php";
			$files[]= SITE_ROOT_PATH . "/components/com_joomblog/functions.joomblog.php";
			$files[]= SITE_ROOT_PATH . "/components/com_joomblog/joomblog.php";
			$files[]= SITE_ROOT_PATH . "/components/com_joomblog/template.php";
			
			if (sizeof($files))
			foreach ($files as $file)
			{
				if (is_file($file)) 	JFile::delete($file);
			}
			
        }
 
        /**
         * method to run after an install/update/uninstall method
         *
         * @return void
         */
        function postflight($type, $parent)
        {
			$mainframe	=& JFactory::getApplication();

			require_once( JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_joomblog' . DS . 'install.sql.php' );
			
						
			$this->_createAvatarFolder();
			$this->_FixMenuLinks();
			$this->_ExtractFiles();
			$this->_FixDBTables();
			$this->_UpdateAssetCategories();
			//$this->_UpdateRulesComponent();
        
        ?>
			<font style="font-size:2em; color:#55AA55;" >JoomBlog component successfully installed.</font><br/><br/>
			<table border="1" cellpadding="5" width="100%" style="background-color: #F7F8F9; border: solid 1px #d5d5d5; width: 100%; padding: 10px; border-collapse: collapse;">		
				<tr>
					<td colspan="2" style="background-color: #e7e8e9;text-align:left; font-size:16px; font-weight:400; line-height:18px "><strong><img src="<?php echo JURI::base(); ?>components/com_joomblog/assets/images/tick.png"> Getting started.</strong> Helpfull links:</td>
				</tr>
				<tr>
					<td colspan="2" style="padding-left:20px">
						<div style="font-size:1.2em">
							<ul>
								<li><a href="<?php echo JURI::base(); ?>index.php?option=com_joomblog&view=sampledata">Install Sample Data</a></li>
								<li><a href="<?php echo JURI::base(); ?>index.php?option=com_joomblog&view=about">About JoomBlog</a></li>
								<li><a href="<?php echo JURI::base(); ?>index.php?option=com_joomblog&view=help">Component's help</a></li>
								<li><a href="http://www.joomplace.com/forum/joomla-components/joomblog.html" target="_blank">Support forum</a></li>
								<li><a href="http://www.joomplace.com/helpdesk/ticket_submit.php" target="_blank">Submit request to our technicians</a></li>
							</ul>
						</div>
					</td>
				</tr>
				<tr>
					<td colspan="2" style="background-color: #e7e8e9;text-align:left; font-size:14px; font-weight:400; line-height:18px "><strong><img src="<?php echo JURI::base(); ?>components/com_joomblog/assets/images/tick.png">Latest changes: </strong></td>
				</tr>
			</table>
		<?php
        	jimport( 'joomla.filesystem.file' );
			$file		= JPATH_ROOT . DS . 'administrator' . DS .'components' . DS . 'com_joomblog' . DS . 'changelog.txt';
			if (file_exists($file))
			{
				$content	= JFile::read( $file );
				echo '<pre>'.$content.'</pre>';	
			}	
        }
        
        /*function _UpdateRulesComponent(){
			$db	=& JFactory::getDBO();
			
			$db->setQuery("SELECT rules FROM #__assets WHERE name = 'com_joomblog' ");
			if($db->loadResult() == "{}" || !$db->loadResult()){
				$db->setQuery('UPDATE #__assets SET rules=\'{"core.admin":{"1":0,"6":0,"7":0,"2":0,"3":0,"4":0,"5":0,"10":0,"12":0,"8":0},"core.manage":{"1":0,"6":0,"7":0,"2":0,"3":0,"4":0,"5":0,"10":0,"12":0,"8":0},"core.create":{"1":1,"6":1,"7":1,"2":1,"3":1,"4":1,"5":1,"10":1,"12":1,"8":0},"core.delete":{"1":1,"6":1,"7":1,"2":1,"3":1,"4":1,"5":1,"10":1,"12":1,"8":0},"core.edit":{"1":1,"6":1,"7":1,"2":1,"3":1,"4":1,"5":1,"10":1,"12":1,"8":0},"core.edit.state":{"1":1,"6":1,"7":1,"2":1,"3":1,"4":1,"5":1,"10":1,"12":1,"8":0},"core.edit.own":{"1":1,"6":1,"7":1,"2":1,"3":1,"4":1,"5":1,"10":1,"12":1,"8":0}}\' WHERE name = "com_joomblog" ');
				$db->query();
			}
        }*/
        
        function _UpdateAssetCategories(){
			$db	=& JFactory::getDBO();
			
			$query = "SELECT * FROM #__assets  WHERE name = 'com_joomblog' ";
			$db->setQuery( $query );
			$com = $db->loadObject();
			
			$cat1 = array();
			if (is_object($com)){
				$query = "SELECT c.* FROM #__categories AS c, #__assets AS a WHERE c.asset_id = a.id AND c.extension = 'com_joomblog' AND  a.parent_id <> ".$com->id;
				$db->setQuery( $query );
				$cat1 = $db->loadObjectList();
			}
			
			if (!empty($cat1)){
				foreach($cat1 as $value){
					$db->setQuery("UPDATE #__assets SET parent_id = ".$com->id." WHERE name = 'com_joomblog.category.".$value->id."' ");
					$db->query();
				}
			}
			
			/*$query = "SELECT c.* FROM #__categories AS c  LEFT JOIN #__assets AS a ON c.asset_id = a.id WHERE c.extension = 'com_joomblog' AND a.id is NULL ";
			$db->setQuery( $query );
			$cat2 = $db->loadObjectList();

			$query = "SELECT MAX(lft) FROM #__assets ";
			$db->setQuery( $query );
			$max_lft = $db->loadResult();
			
			$max_lft = $max_lft+2;
			$max_rgt = $max_lft+1;
			
			if (is_object($com)){
			if (!empty($cat2)){
				foreach($cat2 as $value){
					$db->setQuery( "
						INSERT INTO #__assets SET 
						parent_id = ".$com->id." , 
						lft = ".$max_lft." , 
						rgt = ".$max_rgt." , 
						level = 2 , 
						name = 'com_joomblog.category.".$value->id."' , 
						title = '".$value->title."' , 
						rules = '{\"core.edit.state\":[],\"core.edit\":[],\"core.delete\":[]}' " );
					$db->query();
				
					$db->setQuery('UPDATE #__categories SET asset_id = '.$db->insertid().' WHERE id = '.$value->id);
					$db->query();
	
					$max_lft = $max_lft+2;
					$max_rgt = $max_lft+1;	
				}
			}
			}*/
        }
        
        function _FixDBTables()
		{
			$db	=& JFactory::getDBO();
			
			$query	= 'SHOW FIELDS FROM `#__joomblog_tags`';
			
			$db->setQuery( $query );
			$fields = $db->loadObjectList();
		
			if(empty($fields[1]->Key)){
				$db->setQuery("ALTER TABLE `#__joomblog_tags` ADD UNIQUE (`name`)");
				$db->query();
			}
		}
		
		function _ExtractFiles()
		{
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/frontend.zip", SITE_ROOT_PATH . "/components/com_joomblog/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/backend.zip", SITE_ROOT_PATH . "/administrator/components/com_joomblog/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_archive.zip", SITE_ROOT_PATH . "/modules/mod_jb_archive/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_categories.zip", SITE_ROOT_PATH . "/modules/mod_jb_categories/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_latestposts.zip", SITE_ROOT_PATH . "/modules/mod_jb_latestposts/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_popularbloggers.zip", SITE_ROOT_PATH . "/modules/mod_jb_popularbloggers/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_tags.zip", SITE_ROOT_PATH . "/modules/mod_jb_tags/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/mod_jb_blogs.zip", SITE_ROOT_PATH . "/modules/mod_jb_blogs/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/plg_joomblog.zip", SITE_ROOT_PATH . "/plugins/system/joomblog/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/plg_social.zip", SITE_ROOT_PATH . "/plugins/editors-xtd/social/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/plg_joombloguser.zip", SITE_ROOT_PATH . "/plugins/user/joombloguser/");
			JArchive::extract(SITE_ROOT_PATH . "/administrator/components/com_joomblog/install/plg_joomblogcontent.zip", SITE_ROOT_PATH . "/plugins/content/joomblogcontent/");
			
			jimport( 'joomla.installer.installer' );
			$installer = new JInstaller();
			
			$db	=& JFactory::getDBO();
			$query = "SELECT extension_id FROM #__extensions WHERE ( type = 'module' OR type = 'plugin' ) AND element IN ('mod_jb_archive', 'mod_jb_categories', 'mod_jb_latestposts', 'mod_jb_popularbloggers', 'mod_jb_tags', 'mod_jb_blogs', 'joomblog', 'social', 'joombloguser', 'joomblogcontent') ";
			$db->setQuery($query);
			$extensions_id = $db->loadResultArray();
			foreach($extensions_id as $value){
			  $installer->refreshManifestCache($value);
			}
		}
		
		function _FixMenuLinks()
		{
			$db	=& JFactory::getDBO();
			
			$query = "SELECT `extension_id` FROM #__extensions WHERE `type` = 'component' AND `element`='com_joomblog'";
			$db->setQuery( $query );
			
			$comid	= $db->loadResult();
			$query = "UPDATE #__menu SET `component_id`='$comid' WHERE `link` LIKE 'index.php?option=com_joomblog%'";
			$db->setQuery($query);
			$db->query();
		}
		
		function _createAvatarFolder(){
			
			
			$joomblog_folder = JPATH_ROOT.DS.'images'.DS.'joomblog';
			if (!JFolder::exists($joomblog_folder)){
				if (!JFolder::create($joomblog_folder, 0755)) {
						 echo JString::str_ireplace("'", "\\'", JText::_('Can not create images/joomblog folder'));
						 jexit();
				}
			}
			
			$avatar_folder = $joomblog_folder.DS.'avatar';
			if (!JFolder::exists($avatar_folder)){
				if (!JFolder::create($avatar_folder, 0755)) {
						 echo JString::str_ireplace("'", "\\'", JText::_('Can not create images/joomblog folder'));
						 jexit();
				}
			}
			
		}
}

?>