<?php

// no direct access
defined('_JEXEC') or die('Restricted access');
require_once( JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');

if(!class_exists('plgCommunityMyblogposts'))
{
	class plgCommunityMyblogposts extends CApplications
	{
		var $_user		= null;
		var $_name		= "My Blog Posts";
		var $name		= "My Blog Posts"; //old versions
		var $_path		= '';
		var $db			= null;
		var $doc		= null;
		var $my			= null;
		var $_count		= 5;
		
	    function plgCommunityMyblogposts(& $subject, $config)
	    {
			$this->_user	= CFactory::getRequestUser();
			$this->db   	=& JFactory::getDBO();
			$this->doc		=& JFactory::getDocument();
			$this->my		= CFactory::getUser();
			$this->_path	= JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_joomblog'; 
			parent::__construct($subject, $config); 
	    }
 	 	 	 		
		function onProfileDisplay()
		{
			//Load language file.
			 JPlugin::loadLanguage( 'plg_myblogposts', JPATH_ADMINISTRATOR );
			
			//Attach JS & CSS
			 $this->doc->addStyleSheet( JURI::root() . 'plugins/community/myblogposts/myblogposts/style.css');
			 $this->doc->addScript( JURI::root() . 'plugins/community/myblogposts/myblogposts/blogpostwindow.js' );
			 
			//If JoomBlog not exists
			 if(!file_exists($this->_path . DS . 'joomblog.php' ) )
				{
					$content = "<table class='myblogposts-notice'>
									<tr>
										<td>
							            	<img src='".JURI::root()."components/com_community/assets/error.gif' alt='' />
							        	</td>
							        	<td> " .JText::_('PLG_MYBLOPOSTS_JOOMBLOGNOTFOUND') . "</td>
									</tr>
								</table>";
				}else
				{
					//Get Blog Posts
					$items = $this->_getBlogPosts();
					
					//Get owner
					$isOwner	= ($this->my->id == $this->_user->id ) ? true : false;
					$ownerId 	= (int) $this->_user->id;
					$ownerMame	= $this->_getUsernameById($ownerId);
					
					//Cache work
					$caching = $this->params->get('cache', 1);		
						if ($caching) { $caching = JFactory::getApplication()->getCfg('caching');}
					
					$cache =& JFactory::getCache('plgCommunityMyblogposts');
					$cache->setCaching($caching);
					$callback = array('plgCommunityMyblogposts', '_getBlogHTML');
					$content = $cache->call($callback, $items, $isOwner, $ownerMame, $this->params);
				}					
			return $content;
		}
		
		private function _getBlogPosts()
		{
			$date =& JFactory::getDate();
			
			$limit = $this->params->get('count', 5);
			
			//Get JoomBlog categories
			 $categories = $sections = array(0);
			 $this->db->setQuery(" SELECT * FROM #__categories " .
						  " WHERE extension ='com_joomblog' AND `published`='1' " .
						  " ORDER BY title ");
			 $categories = $this->db->loadResultArray();
			 if (sizeof($categories)) $sections = implode(',',$categories);
			
			//MAIN SQL QUERY			
			 $query = " SELECT DISTINCT a.*,`p`.`posts`, `p`.`comments`  FROM `#__content` as `a` " .
					  " LEFT JOIN `#__joomblog_privacy` AS `p` ON `p`.`postid`=`a`.`id` ".
					  " WHERE `a`.`state`=1 AND `a`.`publish_up` < '" . $date->toMySQL() . "' " .
					  (sizeof($sections)?" AND `a`.`catid` IN ($sections) ":" ").
					  " AND `a`.`created_by` = " .$this->_user->id.
					  " ORDER BY `a`.`created` DESC " .
					  " ";
			 $this->db->setQuery($query);
			 $items  = $this->db->loadObjectList();
			 $this->_getBlogs($items); 								//find blogs names&links
			 $items = $this->_setRowsByPrivacyFilter($items);		//set privacy rules
			if($this->db->getErrorNum()) {
				JError::raiseError( 500, $this->db->stderr());
			}
			return $items;
		}
		
		function _getBlogHTML($items=null, $isOwner=false, $ownerMame='', $params=null)
		{
			$html = "";
			
			if(!empty($items))
			{	
				if ($isOwner)
				{				
					$blogModerateLink = "javascript:blogShowWindow('".JRoute::_("index.php?option=com_joomblog&task=adminhome&tmpl=component")."');";
					$html .= '<div class="moderatelink">
									<a href="javascript:void(0);" onclick="'.$blogModerateLink.'">'.
											JText::_('PLG_MYBLOPOSTS_MODERATE_BLOGPOSTS').'</a>
								</div>';
					
					$blogWriteLink = JRoute::_("index.php?option=com_joomblog&task=write&id=0&tmpl=component");
					$blogWriteLink ="javascript:blogShowWindow('".$blogWriteLink."');";
					
					$html .= '<div class="createlink">
									<a href="javascript:void(0);" onclick="'.$blogWriteLink.'">'.
											JText::_('PLG_MYBLOPOSTS_NEW_BLOGPOSTS').'</a>
								</div><br/>';
				}
				$html .= '<ul class="myblogposts" id="myblogposts">';
				
				$limit = $params->get('count', 5);
				$t=0;
				foreach($items as $blogger)
				{	
					if ($t>$limit) break;	
					$t++;
					$html .= '<li>';	
					$blogLink 	 = JRoute::_('index.php?option=com_joomblog&blogid='.$blogger->bid.'&view=blogger');
					$articleLink = JRoute::_('index.php?option=com_joomblog&show='.$blogger->id);
																
					$html .= '<table cellpadding="0" cellspacing="0" border="0" width="100%" class="myblogposts-header">';
					$html .= '	<tr>';
					$html .= '		<td height="20">' .
										'<div class="myblogposts-title">' .
											'<a href="'.$blogLink.'">'.$blogger->btitle.'</a> ' .
											'<span class="blog-sep">→</span> ' .
											'<a href="'.$articleLink.'" class="blog">'.$blogger->title.'</a>' .
										'</div>' .
									'</td>';
					$html .= '		<td valign="top" width="200" class="blogcreatedate">'.
									date(JText::_('DATE_FORMAT_LC2'), strtotime($blogger->created));
					$html .='<div><small class="category-bgk">'.$blogger->jcategory.'</small></div></td>';
					$html .= '	</tr>';
										
					$html .= '</table>';	
					$html .= '</li>';
			
				}
				$html .= '</ul>';
				
				$blogAllLink = "javascript:blogShowWindow('".JRoute::_("index.php?option=com_joomblog&user=$ownerMame&tmpl=component")."');";				
				$html .= '<div style="float:right;">
								<a href="javascript:void(0);" onclick="'.$blogAllLink.'">'.
										JText::_('PLG_MYBLOPOSTS_SHOW_ALL').'</a>
							</div>';
			}else{
				$html .= '<div>'.JText::_('PLG_MYBLOPOSTS_NO_BLOGPOSTS').'</div>';
			}				
			$html .= '<div style="clear:both;"></div>';
			return $html;
		}
		
		function onAppDisplay(){
			ob_start();
			$limit=0;
			$html= $this->onProfileDisplay($limit);
			echo $html;
			
			$content	= ob_get_contents();
			ob_end_clean(); 
		
			return $content;		
		}
		
	private function _setRowsByPrivacyFilter($rows=null)
	{
		$user	=& JFactory::getUser();
		if (sizeof($rows))
		{
			for ( $i = 0, $n = sizeof( $rows ); $i < $n; $i++ ) 
			{
				$post = &$rows[$i];
				$post->posts?$post->posts:$post->posts=0;
				if (!isset($post->bid)) {unset($rows[$i]); $this->totalEntries--;}
				switch ( $post->posts ) 
				{
					case 0:	break;
					case 1:	
						if (!$user->id) 
						{
							$rows[$i]=null;
							unset($rows[$i]);
							$this->totalEntries--;
						}
					break;
					case 2:	
						if (!$user->id) 
						{
							unset($rows[$i]);
							$this->totalEntries--;
						}else
						{
							if (!$this->_isFriends($user->id, $post->created_by) && $user->id!=$post->created_by)
							{
								unset($rows[$i]);
								$this->totalEntries--;
							}	
						}						
					break;
					case 3:	
						if (!$user->id) 
						{
							unset($rows[$i]);
							$this->totalEntries--;
						}else
						{
							if ($user->id!=$post->created_by)
							{
								unset($rows[$i]);
								$this->totalEntries--;
							}	
						}						
					break;
				}
			}
			$rows = array_values($rows);
		}
		return $rows;
	}
	
	private function _isFriends($id1=0,$id2=0)
	{
		$db	=& JFactory::getDBO();
		$db->setQuery(	" SELECT `connection_id` FROM `#__community_connection` " .
						" WHERE connect_from=".(int)$id1." AND connect_to=".(int)$id2." AND `status`=1 ");
		$frindic = $db->loadResult();
		if ($frindic) return true; else return false;				
	}
		
		private function _getBlogs(&$rows)
		{
			$db	=& $this->db;
			$user	=& JFactory::getUser();
			if(count($rows))
			{
				for($i =0; $i < count($rows); $i++)
				{
					$row    =& $rows[$i];
				
				$db->setQuery(" SELECT b.blog_id as bid, lb.title as btitle, p.posts, p.comments  " .
						      " FROM #__joomblog_blogs as b, #__joomblog_list_blogs as lb " .
						      " LEFT JOIN `#__joomblog_privacy` AS `p` ON `p`.`postid`=`lb`.`id` AND `p`.`isblog`=1 ".
						      " WHERE b.content_id=".$row->id." AND lb.id = b.blog_id AND lb.approved=1 AND lb.published=1 ");
				$blogs = $db->loadObjectList();
				
				if (sizeof($blogs)) 
				{
				switch ( $blogs[0]->posts ) 
				{
					case 0:	break;
					case 1:	
						if (!$user->id) 
						{
							$row->posts = $blogs[0]->posts;
						}
					break;
					case 2:	
						if (!$user->id) 
						{
							$row->posts = $blogs[0]->posts;
						}else
						{
							if (!$this->_isFriends($user->id, $row->created_by) && $user->id!=$row->created_by)
							{
								$row->posts = $blogs[0]->posts;
							}	
						}
					break;
					case 3:	
						if (!$user->id) 
						{
							$row->posts = $blogs[0]->posts;
						}else
						{
							if ($user->id!=$row->created_by)
							{
								$row->posts = $blogs[0]->posts;
							}	
						}						
					break;
				}					
				$row->bid = $blogs[0]->bid;
				$row->btitle = $blogs[0]->btitle;
				$row->jcategory		= '<a class="category" href="' . JRoute::_('index.php?option=com_joomblog&task=tag&category=' . $row->catid ) . '">' . $this->_getJoomlaCategoryName( $row->catid ) . '</a>';
				$row->categories	= $this->_categoriesURLGet($row->id, true);
				}
				
				
/*						      
					$db->setQuery("SELECT b.blog_id as bid, lb.title as btitle " .
							" FROM #__joomblog_blogs as b, #__joomblog_list_blogs as lb " .
							" WHERE b.content_id=".$row->id." AND lb.id = b.blog_id");
					$blogs = $db->loadObjectList();
				
					$row->bid = $blogs[0]->bid;
					$row->btitle = $blogs[0]->btitle;
					$row->jcategory		= '<a class="category" href="' . JRoute::_('index.php?option=com_joomblog&task=tag&category=' . $row->catid ) . '">' . $this->_getJoomlaCategoryName( $row->catid ) . '</a>';
					$row->categories	= $this->_categoriesURLGet($row->id, true);
*/
				}
			}
		}
		
		private function _getJoomlaCategoryName($id)
		{			
			$db		=& JFactory::getDBO();
			$query	= "SELECT `title` FROM #__categories WHERE `id`='$id' ";
			$db->setQuery( $query );
			return $db->loadResult();
		}

		private function _getTags($contentid)
		{
			$db =& JFactory::getDBO();
			
			$query = "SELECT b.id,b.name, '' AS slug FROM #__joomblog_content_tags as a,#__joomblog_tags as b WHERE b.id=a.tag AND a.contentid='$contentid' ORDER BY b.name DESC";
			$db->setQuery( $query );
			$result = $db->loadObjectList();
			echo $db->getErrorMsg();
			for($i = 0; $i < count($result); $i++)
			{
				$tag	= $result[$i];
				
				if($tag->slug == '')
					$tag->slug	= $tag->name;
			}
		
			return $result;
		}
		
		private function _categoriesURLGet($contentid, $linkCats = true, $task="")
		{			
			$result		= $this->_getTags($contentid);
			$catCount	= count($result);
			$link		= "";
			$task		= empty($task) ? '&task=tag' : "&task=$task" ;
			
			if($result)
			{
				$count = 0;
				
				foreach ($result as $row)
				{
					if ($link != "")
						$link .= ",&nbsp;";
					
					if ($linkCats)
					{
						$url	= JRoute::_('index.php?option=com_joomblog' . $task . '&tag=' . urlencode($row->slug));				
						$link .= "<a href=\"$url\">$row->name</a>";
					}
					else
					{
						$link .= $row->name;
					}
					$count++;
				}
			}
			else
			{
				$link .= "<em>". JText::_('BLOG UNTAGGED') ."</em>&nbsp;";
			}
			
			return $link;
		}
		
		private function _getUsernameById($ownerId=42)
		{
			$db		=& JFactory::getDBO();
			$query	= "SELECT `username` FROM #__users WHERE `id`='$ownerId' ";
			$db->setQuery( $query );
			return $db->loadResult();	
		}
	}
}
